--- asterisk-1.4.34/main/channel.c.orig	2010-08-03 15:47:27.372064600 +0200
+++ asterisk-1.4.34/main/channel.c	2010-08-03 15:35:51.002928800 +0200
@@ -4318,6 +4318,17 @@
 		pthread_kill(original->blocker, SIGURG);
 	if (option_debug) 
 		ast_log(LOG_DEBUG, "Done Masquerading %s (%d)\n", original->name, original->_state);
+       if (original->_bridge) {
+          ast_channel_lock(original->_bridge);
+          ast_indicate(original->_bridge, AST_CONTROL_SRCCHANGE);
+          ast_channel_unlock(original->_bridge);
+        }
+        if (original) {
+          ast_channel_lock(original);
+          ast_indicate(original, AST_CONTROL_SRCCHANGE);
+          ast_channel_unlock(original);
+        }
+ 
 	return 0;
 }
 
